﻿Imports System.Threading
Public Class frmMain
  Protected Overrides Sub OnPaint(ByVal e As System.Windows.Forms.PaintEventArgs)
    Dim g As Graphics
    Dim p As Pen
    p = New Pen(System.Drawing.Color.Red, 2)
    g = e.Graphics
    g.DrawLine(p, 20, 60, 440, 60)
  End Sub

  Private Sub btnGetRGBDevice_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGetRGBDevice.Click
    'GetRGBDevice
    txtReturn.Text = dll_comm.GetRGBDevice() & " connected device"
  End Sub

  Private Sub btnGetRGBStatus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGetRGBStatus.Click
    'GetRGBStatus
    txtReturn.Text = dll_comm.GetRGBStatus(1, barRed.Value, barGreen.Value, barBlue.Value)
    picColor.BackColor = System.Drawing.Color.FromArgb(barRed.Value * 255 / 100, barGreen.Value * 255 / 100, barBlue.Value * 255 / 100)
  End Sub

  Private Sub btnSetRGBStatus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSetRGBStatus.Click
    'SetRGBStatus
    txtReturn.Text = dll_comm.SetRGBStatus(1, barRed.Value, barGreen.Value, barBlue.Value)
  End Sub

  Private Sub btnSetRGBStatusOnPower_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSetRGBStatusOnPower.Click
    'SetRGBStatusOnPower
    txtReturn.Text = dll_comm.SetRGBStatusOnPower(1, barRed.Value, barGreen.Value, barBlue.Value)
  End Sub

  Private Sub btnGetVersion_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGetVersion.Click
    'GetRGBFirmwareVersion 
    'GetLibVersion
    Dim FWmajor, FWminor, FWbuild As Integer
    Dim LIBmajor, LIBminor As Integer

    txtReturn.Text = "FW: " & dll_comm.GetRGBFirmwareVersion(1, FWmajor, FWminor, FWbuild) ' Read Firmware Version of device 1
    txtOutput.Text = "Firmware Version: " & FWmajor & "." & FWminor & "." & FWbuild & vbCrLf & vbCrLf

    txtReturn.Text += " LIB: " & dll_comm.GetLibVersion(LIBmajor, LIBminor) ' Read DLL-Library Version
    txtOutput.Text += "Library Version: " & LIBmajor & "." & LIBminor & vbCrLf & vbCrLf
  End Sub

  Private Sub btnGetInfo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGetInfo.Click
    'Testfunktion
    'GetRGBDeviceSerial
    'GetRGBDeviceLocation
    Dim serial_0, serial_1, serial_2, loc_id As Integer

    txtReturn.Text = "Serial: " & dll_comm.GetRGBDeviceSerial(1, serial_0, serial_1, serial_2)
    txtOutput.Text = "Serial ID:" & serial_0 & "-" & serial_1 & "-" & serial_2 & vbCrLf

    txtReturn.Text += " Loc: " & dll_comm.GetRGBDeviceLocation(1, loc_id)
    txtOutput.Text += "Location ID:" & loc_id & vbCrLf & vbCrLf

  End Sub

  Private Sub bar_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles barRed.Scroll, barGreen.Scroll, barBlue.Scroll
    'Refresh picColor Field on Form
    picColor.BackColor = System.Drawing.Color.FromArgb(barRed.Value * 255 / 100, barGreen.Value * 255 / 100, barBlue.Value * 255 / 100)
  End Sub

  Private Sub btnInfo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnInfo.Click
    frmInfo.ShowDialog()
  End Sub

  Private Sub CheckBox1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox1.CheckedChanged
    If (CheckBox1.Checked = True) Then
      'Demo Mode ON
      Timer1.Interval = 1000
      Timer1.Enabled = True
      groupFct.Enabled = False
      groupColour.Enabled = False
    Else
      'Demo Mode OFF
      Timer1.Enabled = False
      groupFct.Enabled = True
      groupColour.Enabled = True
    End If
  End Sub
  Dim color As Byte(,) = {{100, 0, 0}, {100, 80, 0}, {0, 100, 0}, {0, 0, 100}, {100, 0, 100}, {0, 100, 100}, {100, 100, 100}}
  Dim colorSelect As Byte = 0
  Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick

    dll_comm.SetRGBStatus(1, color(colorSelect, 0), color(colorSelect, 1), color(colorSelect, 2))
    barRed.Value = color(colorSelect, 0)
    barGreen.Value = color(colorSelect, 1)
    barBlue.Value = color(colorSelect, 2)
    picColor.BackColor = System.Drawing.Color.FromArgb(barRed.Value * 255 / 100, barGreen.Value * 255 / 100, barBlue.Value * 255 / 100)

    colorSelect = colorSelect + 1
    If (colorSelect > 6) Then colorSelect = 0
  End Sub
End Class
